using System;
using System.Runtime.InteropServices ;

namespace shobonjtag
{
	/// <summary>
	/// p|[gڑ ByteBlaterMV P[uɂ TAP ڑ
	/// igiveio.sys ̃CXg[Ɠ giveio.dll Kvłj
	/// </summary>
	public sealed class ByteBlasterMV : JtagCable
	{
		// p|[g̃rbg蓖ĂȂ
		// gppP[uɂĕς
		// 
		// /STROBE(1),/AUTOFD(14) : ]
		// D0(2),D1(3),D3(4),D4(5),D5(6),D6(7),D7(8) : 񔽓]@炵B

		// AhX LPDAT
		const int D7     = 0x80 ;
		const int D6     = 0x40 ;
		const int D5     = 0x20 ;
		const int D4     = 0x10 ;
		const int D3     = 0x08 ;
		const int D2     = 0x04 ;
		const int D1     = 0x02 ;
		const int D0     = 0x01 ;

		const int TDIBIT  = D6 ;
		const int TCKBIT  = D0 ;
		const int TMSBIT  = D1 ;

		// AhX LPSTA
		const int nBUSY  = 0x80 ;
		const int nACK   = 0x40 ;
		const int PE     = 0x20 ;
		const int SLCT   = 0x10 ;
		const int nERR   = 0x08 ;
		
		const int TDOBIT  = nBUSY ; // /BUSY

		// AhX LPCON
		// QlFhttp://www.lvr.com/files/ibmlpt.txt
		//
		// The BIOS normally keeps the Control register value as 0x0C:
		// C5 = 0  =>  output enabled (for bidirectional only)
		// C4 = 0  =>  IRQ disabled
		// C3 = 1  =>  -Select pin low    (Printer Selected)
		// C2 = 1  =>  -Init pin high     (Printer not being initialized)
		// C1 = 0  =>  -AutoFeed pin high (No Auto Feed)
		// C0 = 0  =>  -Strobe pin high   (No Stobe)
		const int DIRC   = 0x20 ;
		const int IRQE   = 0x10 ;
		const int SLIN   = 0x08 ;
		const int IPRT   = 0x04 ;
		const int ATFD   = 0x02 ;
		const int STRB   = 0x01 ;

		int LPTBASE ; // 0x378,0x278,0x3BC
		int lastlpdat = 0x00 ;

		// p|[g̃AhX蓖
		int LPDAT,LPSTA,LPCON ;
		int TDIPORT,TCKPORT,TDOPORT ;

		// giveio.sys oR inp(),outp() g DLL
		[DllImport("giveio.dll")]
		static extern int Opengiveio() ;

		[DllImport("giveio.dll")]
		static extern int Inp(int port) ;

		[DllImport("giveio.dll")]
		static extern void Outp(int port,int data) ;

		/// <summary>
		/// RXgN^
		/// </summary>
		/// <param name="port">LPT ̃x[XAhX</param>
		public ByteBlasterMV(int port) {			
			LPTBASE = port ;
			LPDAT   = LPTBASE + 0x00 ;
			LPSTA   = LPTBASE + 0x01 ;
			LPCON   = LPTBASE + 0x02 ;

			TCKPORT = LPDAT ;
			TDIPORT = LPDAT ;
			TDOPORT = LPSTA ;
		}
		
		/// <summary>
		/// ƃI[v
		/// </summary>
		/// <returns>G[R[hF̐ 0</returns>
		public int Open() {
			int res = Opengiveio() ;
			// ʏ SLIN+IPRTiLRgQƁj
			//
			// ALTERA ̏݃P[u AutoFeed(14) 
			// obt@ IC ̃Cl[uɌqĂ悤B
			//  LOW ɂKvB
			//
			Outp( LPCON , SLIN + IPRT + ATFD ) ;
			return res ;
		}

		/// <summary>
		/// N[YƊJ
		/// </summary>
		public void Close() {}				

		/// <summary>
		/// TCK  LOW 
		/// </summary>
		public void Tcklow() {
			// Outp( LPCON, SLIN + IPRT + STRB ) ; // /STROBE  TCK ɎgpiQlj
			Outp( TCKPORT , lastlpdat &= (~TCKBIT) ) ; // Use Data Line
		}

		/// <summary>
		/// TCK  HIGH 
		/// </summary>
		public void Tckhigh() {
			// Outp( LPCON , SLIN + IPRT ) ; // /STROBE  TCK ɎgpiQlj
			Outp( TCKPORT , lastlpdat |= TCKBIT ) ; // Use Data Line
		}						  



		/// <summary>
		/// TDO ̓ǂݎ
		/// </summary>
		/// <returns>ǂݎl(1:H,0:L)</returns>
		public int Tdoread() {
			// return (( inp( TDOPORT ) & TDOBIT ) == 0) ? 0 : 1 ; // TDO ͔񔽓]
			return (( Inp( TDOPORT ) & TDOBIT ) == 0) ? 1 : 0 ; // TDO ͔]
		}

		/// <summary>
		/// TMS,TDI ̏o
		/// </summary>
		/// <param name="tms">TMS ̃x (1:H,0:L)</param>
		/// <param name="tdi">TDI ̃x (1:H,0:L)</param>
		public void Tdiout(int tms,int tdi) {
			// TDI,TMS rbgUNA
			lastlpdat &= (~(TDIBIT | TMSBIT)) ;
			// KvȃrbgĂ			
			lastlpdat |= ((tdi * TDIBIT) | (tms * TMSBIT)) ;
			Outp( TDIPORT , lastlpdat ) ;
		}		
	}
}
